// main.go
package main

import (
	"fmt"
	"log"
	"net/http"
)

func handleAuth(w http.ResponseWriter, r *http.Request) {
	_, _, ok := r.BasicAuth()
	if ok {
		w.WriteHeader(http.StatusOK)
		r.ParseMultipartForm(0)
		return
	}
	w.Header().Set("WWW-Authenticate", `Basic realm="Go POST test"`)
	w.WriteHeader(http.StatusUnauthorized)
	fmt.Fprint(w, "Unauthorized")
	return
}

func main() {
	log.Println("Listening on :9090")
	http.HandleFunc("/post", handleAuth)
	http.HandleFunc("/", func(w http.ResponseWriter, r *http.Request) {
		http.ServeFile(w, r, "index.html")
	})
	log.Fatalln(http.ListenAndServe(":9090", nil))
}
